Bug 984995 - EAP server can't be shutdowned when ActiveMQ JCA adapter lost connection JBoss A-MQ server
EAP server can't be shutdowned when ActiveMQ JCA adapter lost connection JBos...
Status: MODIFIED
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: JMS (Show other bugs)
6.1.0
Unspecified Unspecified
unspecified Severity medium
: GA
: EAP 6.4.0
Assigned To: Gary Tully
Miroslav Novak
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-07-16 10:24 EDT by Miroslav Novak
Modified: 2015-08-02 19:47 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
threaddump_during_shutdown.txt (74.22 KB, text/plain)
2013-07-16 10:25 EDT, Miroslav Novak
no flags Details
reproducer.zip (56.86 KB, application/force-download)
2013-07-16 10:26 EDT, Miroslav Novak
no flags Details
server.log (30.24 KB, text/plain)
2013-07-16 10:26 EDT, Miroslav Novak
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker ENTMQ-607 Major Closed AMQ Resource adapter us hung while graceful Jboss shutdown 2017-06-21 01:34 EDT

  None (edit)
Description Miroslav Novak 2013-07-16 10:24:13 EDT
Description of problem:
When MDB deployed in EAP server is processing messages from remote JBoss A-MQ broker then EAP server can't be shutdowned if the connection to broker is lost. Thread dump and EAP server.log attached.

How reproducible:
Download reproducer.zip from the attachment. Following run in "reproducer" directory:

export MYTESTIP_1=127.0.0.1
git clone git://git.app.eng.bos.redhat.com/jbossqe/eap-tests-wsmq.git
cd eap-tests-wsmq
export ROOT=$PWD

#get EAP
wget -P ibm-mq-testsuite/activemq/installs http://download.devel.redhat.com/released/JBEAP-6/6.1.0/jboss-eap-6.1.0.zip
#get JBoss A-MQ
wget -P ibm-mq-testsuite/activemq/installs http://download.devel.redhat.com/released/JBossAMQ/6.0.0/jboss-a-mq-6.0.0.redhat-024.zip
cd ibm-mq-testsuite/activemq
sh setup_ha.sh

export JBOSS_HOME=$ROOT/ibm-mq-testsuite/activemq/target/jboss-eap-6.1
cp mdb.jar $JBOSS_HOME/standalone/deployments/
touch $JBOSS_HOME/standalone/deployments/mdb.jar.dodeploy
cp MessageServletForFailoverTests.war $JBOSS_HOME/standalone/deployments/
touch $JBOSS_HOME/standalone/deployments/MessageServletForFailoverTests.war.dodeploy

Start JBoss A-MQ
$ROOT/ibm-mq-testsuite/activemq/target/jboss-a-mq-1/jboss-a-mq-6.0.0.redhat-024/bin/amq

In different console start EAP:
$JBOSS_HOME/bin/standalone.sh -c standalone-full.xml -b 127.0.0.1

In browser call - this will call the MessageServletForFailoverTests and sends 1000 messages to jms/queue/Q1
http://localhost:8080/MessageServletForFailoverTests/MessageServletForFailoverTests?op=send&jndiName=jms/queue/Q1&count=1000

During sending kill/stop JBoss A-MQ server
Try stop(ctrl-c) EAP server -> hangs, thread dump and server.log attached
Comment 1 Miroslav Novak 2013-07-16 10:25:26 EDT
Created attachment 774329 [details]
threaddump_during_shutdown.txt
Comment 2 Miroslav Novak 2013-07-16 10:26:08 EDT
Created attachment 774330 [details]
reproducer.zip
Comment 3 Miroslav Novak 2013-07-16 10:26:37 EDT
Created attachment 774331 [details]
server.log
Comment 4 Miroslav Novak 2014-07-04 08:55:27 EDT
This is still an issue and should be fixed. Setting target version EAP 6.4.0.
Comment 5 Gary Tully 2014-12-22 10:03:54 EST
From the threaddump_during_shutdown - the shutdown is waiting for a failover reconnect. This can be avoided by configuring the failover transport to not do reconnects.
failover:(tcp://master:x,tcp:slave:y)?maxReconnectAttempts=0&startupMaxReconnectAttempts=0

Because the RAR tracks connection failure, it only needs the failover transport to choose from a list of urls, it should not use the blocking auto reconnect feature of failover.
Comment 6 JBoss JIRA Server 2014-12-22 10:08:04 EST
Gary Tully <gary.tully@gmail.com> updated the status of jira ENTMQ-607 to Resolved
Comment 7 JBoss JIRA Server 2015-05-26 04:02:25 EDT
Andrej Vano <avano@redhat.com> updated the status of jira ENTMQ-607 to Closed

Note You need to log in before you can comment on or make changes to this bug.